### Method

# Gio InputStream read_all

#### Declaration

    gboolean
    g_input_stream_read_all (
      GInputStream* stream,
      void* buffer,
      gsize count,
      gsize* bytes_read,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Tries to read `count` bytes from the stream into the buffer starting at `buffer`. Will block during this read.

This function is similar to g_input_stream_read(), except it tries to read as many bytes as requested, only stopping on an error or end of stream.

On a successful read of `count` bytes, or if we reached the end of the stream, `TRUE` is returned, and `bytes_read` is set to the number of bytes read into `buffer`.

If there is an error during the operation `FALSE` is returned and `error` is set to indicate the error status.

As a special exception to the normal conventions for functions that use `GError`, if this function returns `FALSE` (and sets `error`) then `bytes_read` will be set to the number of bytes that were successfully read before the error was encountered. This functionality is only available from C. If you need it from another language then you must write your own loop around g_input_stream_read().

#### Parameters

`buffer`

  Type: An array of `guint8`

      a buffer to read data into (which should be at least count bytes long).

  The argument will be set by the function.
  The length of the array is specified in the `count` argument.
  The data is owned by the instance.

`count`

  Type: `gsize`

  The number of bytes that will be read from the stream.

`bytes_read`

  Type: `gsize*`

  Location to store the number of bytes that was read from the stream.

  The argument will be set by the function.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` on success, `FALSE` if there was an error.